;Procesorem rizeny gong - SAE800 verze 1
;Rizeni vnitrnim krystalem. Vyber ze tri druhu gongu
;Nastaveni zpozdeni reakce na stlaceni tlacitka zvonku

	LIST P=12F629, R=DEC
	INCLUDE<P12F629.INC>
	__CONFIG 0x3F84

W	EQU	0	;nastaveno pro umisteni vysledku
F	EQU	1	;operaci
OFFRAM	EQU	20h	;zacatek volne pameti procesoru

;--------promene------------------------			
PSW		EQU	OFFRAM		;registr priznaku
TGONG	EQU	OFFRAM+1
TZPOZ	EQU	OFFRAM+2
ZVON	EQU	OFFRAM+3
CEK		EQU	OFFRAM+4
CEK1	EQU	OFFRAM+5
CEK2	EQU	OFFRAM+6

;--------definice----------------------
#DEFINE	TLAC1	GPIO,3	;tlacitko zvonku
#DEFINE	TLAC2	GPIO,1	;typ gongu
#DEFINE	TLAC3	GPIO,0	;nastaveni zpozdeni zvonku
#DEFINE	GONG1	GPIO,2	;Single gong
#DEFINE	GONG2	GPIO,4	;Dual gong
#DEFINE	LEDZ	GPIO,5	;Signalizace bez zpozdeni
#DEFINE	STLZVO	PSW,2	;stisk tlacitka zvonek
#DEFINE	STLTYP	PSW,1	;stisk tlacitka typ gongu
#DEFINE	STLZPO	PSW,0	;stisk tlacitka zpozdeni

	ORG	00H
	GOTO	START

;----------pomocne programy-------------
;----------cekani-----------------------
CEKEJ1
	MOVLW	5
	MOVWF	CEK2
CE	INCFSZ	CEK,F
	GOTO	$-1
	INCFSZ	CEK1,F
	GOTO	CE
	DECFSZ	CEK2,F
	GOTO	CE
	RETURN

CEKEJ2
	MOVLW	200
	MOVWF	CEK2
CE2	INCFSZ	CEK,F
	GOTO	$-1
	DECFSZ	CEK2,F
	GOTO	CE2
	RETURN
	
;----------kontrola stavu tlacitek------
TLZVO
	BTFSS	TLAC1	;Kontrola stavu tlacitka
	GOTO	TL1
	BCF		STLZVO	;neni stisknute
	RETURN
	
TL1
	BTFSC	STLZVO	;kontrola zda li nebyl jiz akceptovan
	RETURN
	BSF		STLZVO	;nastaveni priznaku tlacitka
	INCF	ZVON
	RETURN
	
TLTYP
	BTFSC	TLAC2
	GOTO	TL2
	BCF		STLTYP	;neni stisknute
	RETURN			;nastaveni zpozdeni
	
TL2
	BTFSC	STLTYP	;kontrola zda li nebyl jiz akceptovan
	RETURN
	BSF		STLTYP	;nastaveni priznaku tlacitka
	INCF	TGONG,F	;zmena typu zvoneni
	MOVFW	TGONG
	SUBLW	3
	BTFSC	STATUS,Z
	CLRF	TGONG
	RETURN	
	
TLZPO
	BTFSC	TLAC3
	GOTO	TL3
	BCF		STLZPO	;neni stisknute
	RETURN			;nastaveni zpozdeni
	
TL3
	BTFSC	STLZPO	;kontrola zda li nebyl jiz akceptovan
	RETURN
	BSF		STLZPO	;nastaveni priznaku tlacitka
	INCF	TZPOZ,F	;zmena typu zvoneni
	MOVFW	TZPOZ
	SUBLW	2
	BTFSC	STATUS,Z
	CLRF	TZPOZ
	RETURN
	
;----------ZVONENI-----------------
ZVONI
	BTFSC	TLAC1		;Kontrola zda li je stale sepnute tlacitko
	RETURN
	MOVF	TZPOZ,F		;Kdyz je nulovy tak bez zpozdeni
	BTFSS	STATUS,Z
	GOTO	ZP			;Jdi na zpozdene zvoneni
	CALL	CEKEJ2
	BTFSC	TLAC1		;opakovana kontrola po 150ms
	RETURN
	GOTO	ZVONI2
	
ZP
	CALL	CEKEJ1
	BTFSC	TLAC1		;opakovana kontrola po 1s
	RETURN
	CALL	CEKEJ1
	BTFSC	TLAC1		;opakovana kontrola po 2s
	RETURN
	CALL	CEKEJ1
	BTFSC	TLAC1		;opakovana kontrola po 3s
	RETURN
	CALL	CEKEJ1
	BTFSC	TLAC1		;opakovana kontrola po 4s
	RETURN
	CALL	CEKEJ1
	BTFSC	TLAC1		;opakovana kontrola po 5s
	RETURN
	NOP

ZVONI2					;Vyber typu gongu a zvoneni
	MOVF	TGONG,F
	BTFSS	STATUS,Z
	GOTO	G2
	BSF		GONG1
	CALL	CEKEJ1
	BCF		GONG1
	GOTO	ENDZVON

G2
	MOVFW	TGONG
	SUBLW	2
	BTFSC	STATUS,Z
	GOTO	G3
	BSF		GONG2
	CALL	CEKEJ1
	BCF		GONG2
	GOTO	ENDZVON
	
G3
	BSF		GONG1
	BSF		GONG2
	CALL	CEKEJ1
	BCF		GONG1
	BCF		GONG2
	
ENDZVON
	CLRF	ZVON
	RETURN
	
;-----------LED--------------------
;signalizace stavu zvoneni bez zpozdeni

LED
	MOVF	TZPOZ,F		;Kdyz je nulovy tak bez zpozdeni
	BTFSS	STATUS,Z
	GOTO	$+3
	BCF		LEDZ		;Rosvit LED
	GOTO	LEDEND
	BSF		LEDZ		;Zhasni LED

LEDEND
	RETURN
	
;----------hlavni program----------
START	
	BCF		STATUS,RP0
	CLRF	GPIO		;Nastaven IO jako digitalni
	MOVLW	0x07		;ne analog
	MOVWF	CMCON
	BSF		STATUS,RP0	;zakladni nastaveni
	MOVLW	B'00001011'
	MOVWF	TRISIO
	BCF		STATUS,RP0
	MOVLW	0x28
	MOVWF	GPIO		;Nulovani vystupniho portu
	CLRF	TGONG
	CLRF	TZPOZ
	CLRF	CEK
	CLRF	CEK1
	CLRF	CEK2
	
MAIN
	CALL	TLZVO
	CALL	TLTYP
	CALL	TLZPO
	MOVF	ZVON,F		;Byl nastaveno zvoneni
	BTFSS	STATUS,Z
	CALL	ZVONI
	CALL	LED
	GOTO	MAIN

	END
